import glob
import os
import sys
import numpy as np
import pandas as pd
from helper_code import *
from team_code import training_code, test_model_reduced_set
from test_model import test_model
from evaluate_model import evaluate_model
import utils


# Init
pathes_to_raw = [     
    'e:\\Krivenko\\Kaggle\\2021\\New20210219\\Full_data\\PhysioNetChallenge2020_Training_2\\Training_2\\',
    'e:\\Krivenko\\Kaggle\\2021\\New20210219\\Full_data\\PhysioNetChallenge2020_Training_CPSC\\Training_WFDB\\',
    'e:\\Krivenko\\Kaggle\\2021\\New20210219\\Full_data\\PhysioNetChallenge2020_Training_E\\WFDB\\',    
    'e:\\Krivenko\\Kaggle\\2021\\New20210219\\Full_data\\PhysioNetChallenge2020_Training_PTB-XL\\WFDB\\',
    'e:\\Krivenko\\Kaggle\\2021\\New20210219\\Full_data\\PhysioNetChallenge2020_Training_PTB\\WFDB\\'
]
path_to_train = ''
path_to_test = ''
mapping_scoring = pd.read_csv('dx_mapping_scored.csv')
classes = list(mapping_scoring['SNOMED CT Code'].values)
#classes = list([270492004, 164889003, 164890007])

# Create folders with train and test data
if 0:
    #utils.create_train_test_folders(pathes_to_raw, path_to_train, path_to_test, classes, 10, 10)
    utils.create_train_test_folders_any_class(pathes_to_raw, path_to_train, path_to_test, classes, 100, 100)
    #utils.create_train_test_folders_all_class(pathes_to_raw, path_to_train, path_to_test, classes, -1, 0)
    
    
# Read scores
if 0:
    scores_directory = 'e:\\Krivenko\\Kaggle\\2021\\New20210219\\ReadyModels\\mfcc\\'
    score = np.load(scores_directory + '2_lead_model.savscores.npy', allow_pickle=True)
    print('2 lead')
    print(score)
    score = np.load(scores_directory + '3_lead_model.savscores.npy', allow_pickle=True)
    print('3 lead')
    print(score)    
    score = np.load(scores_directory + '6_lead_model.savscores.npy', allow_pickle=True)
    print('6 lead')
    print(score)    
    score = np.load(scores_directory + '12_lead_model.savscores.npy', allow_pickle=True)
    print('12 lead')
    print(score)

# Read local score
if 0:
    mapping_scoring = pd.read_csv('dx_mapping_scored.csv')
    classes = list(mapping_scoring['SNOMED CT Code'].values.astype(str))
    if all(is_integer(x) for x in classes):
        classes = sorted(classes, key=lambda x: int(x)) # Sort classes numerically if numbers.
    else:
        classes = sorted(classes) # Sort classes alphanumerically otherwise.
    for i, clas in enumerate(classes):
        print('{0}:{1}'.format(i,clas))

    scores_directory = 'e:\\Krivenko\\Kaggle\\2021\\New20210219\\ReadyModelsSmall\\neurokit2_sym_any_27_small_20\\'
    score = np.load(scores_directory + '2_lead_model.savscores.npy', allow_pickle=True)
    sensitivity = np.load(scores_directory + '2_lead_model.savsensitivity.npy', allow_pickle=True)
    specificity = np.load(scores_directory + '2_lead_model.savspecificity.npy', allow_pickle=True)
    print('2 lead, score={0}, sensitivity={1}, specificity={2}'.format(score, sensitivity, specificity))    
    
# Training
if 0:
    data_directory = '/home/sergey/cinc2021_temp/training_data_small_10/'
    model_directory = '/home/sergey/cinc2021_temp/model/'
    training_code(data_directory, model_directory)

# Testing
if 0:    
    model_directory = '/home/sergey/cinc2021_temp/model/'
    data_directory = '/home/sergey/cinc2021_temp/testing_data_small_10_2lead/'
    output_directory = '/home/sergey/cinc2021_temp/test_outputs/'

    files = glob.glob(output_directory + '*')
    for f in files:
        os.remove(f)

    test_model(model_directory, data_directory, output_directory)    
    #test_model_reduced_set(model_directory, data_directory, output_directory, 12)

# Evaluate
if 1:
    label_directory = '/home/sergey/cinc2021_temp/testing_data_small_10_2lead/'
    output_directory = '/home/sergey/cinc2021_temp/test_outputs/'
    classes, auroc, auprc, auroc_classes, auprc_classes, accuracy, f_measure, f_measure_classes, challenge_metric = evaluate_model(label_directory, output_directory)
    output_string = 'AUROC,AUPRC,Accuracy,F-measure,Challenge metric\n{:.3f},{:.3f},{:.3f},{:.3f},{:.3f}'.format(auroc, auprc, accuracy, f_measure, challenge_metric)
    print(output_string)